-- encodeur ami
-- amidir.vhd

entity amicod is
	port( 	hor, din : in bit ;
		plusout, moinsout : out bit );
end amicod ;

architecture sort_direct of amicod is
subtype ami is bit_vector(2 downto 0) ;
constant mzero : ami := "000" ;
constant pzero : ami := "001" ;
constant moins : ami := "010" ;
constant plus  : ami := "100" ;
signal etat : ami ;
begin
plusout  <= etat(2) ;
moinsout <= etat(1) ;
encode : process
begin
	wait until hor = '1' ;
	case etat is
		when mzero => 	if din = '1' then etat <= plus  ; 
				end if ;
		when pzero => 	if din = '1' then etat <= moins ; 
				end if ;
		when moins => 	if din = '1' then etat <= plus ;
				else etat <= mzero ; 
				end if ;
		when plus  => 	if din = '1' then etat <= moins ;
				else etat <= pzero ; 
				end if ;
		when others =>	etat <= mzero ;
	end case ;
end process encode ;	
end sort_direct ;