-- encodeur ami version pasic
-- amidirpa.vhd

entity amicod is
	port( 	hor, din : in bit ;
		plusout, moinsout : out bit );
attribute pin_numbers of amicod:entity is "hor:40 din:39 moinsout:37 plusout:38 " ;
end amicod ;

architecture sort_direct of amicod is
constant mzero : bit_vector(2 downto 0) := "000" ;
constant pzero : bit_vector(2 downto 0) := "001" ;
constant moins : bit_vector(2 downto 0) := "010" ;
constant plus  : bit_vector(2 downto 0) := "100" ;
signal etat2 : bit ;
signal etat1 : bit ;
signal etat0 : bit ;
attribute fixed_ff of etat2 : signal is "C1" ;
attribute fixed_ff of etat1 : signal is "B1" ;
attribute fixed_ff of etat0 : signal is "A1" ;

begin
plusout  <= etat2 ;
moinsout <= etat1 ;
encode : process
begin
	wait until hor = '1' ;
	case etat2&etat1&etat0 is
		when mzero => 	if din = '1' then 
					etat2 <= '1'  ; 
					etat1 <= '0'  ; 
					etat0 <= '0'  ; 
				end if ;
		when pzero => 	if din = '1' then  
					etat2 <= '0'  ; 
					etat1 <= '1'  ; 
					etat0 <= '0'  ; 
				end if ;
		when moins => 	if din = '1' then 
					etat2 <= '1'  ; 
					etat1 <= '0'  ; 
					etat0 <= '0'  ; 
				else 
					etat2 <= '0'  ; 
					etat1 <= '0'  ; 
					etat0 <= '0'  ; 
				end if ;
		when plus  => 	if din = '1' then 
					etat2 <= '0'  ; 
					etat1 <= '1'  ; 
					etat0 <= '0'  ; 
				else  
					etat2 <= '0'  ; 
					etat1 <= '0'  ; 
					etat0 <= '1'  ; 
				end if ;
		when others =>	
					etat2 <= '0'  ; 
					etat1 <= '0'  ; 
					etat0 <= '0'  ; 
	end case ;
end process encode ;	
end sort_direct ;