-- boucles
-- boucles.vhd

entity cpt100 is
	port( hor : in bit ;
	   un, dix : out integer range 0 to 9 );
end cpt100 ;

architecture boucle of cpt100 is -- non synthtisable
begin
compteur : process 
begin
dizaines : for d in 0 to 9 loop
	dix <= d ;
unites : for u in 0 to 9 loop
	un <= u ;
	wait until hor = '1' ;
end loop unites ;
end loop dizaines ;
end process compteur ;
end boucle ;	

architecture synthese of cpt100 is -- synthtisable
signal d, u : integer range 0 to 9 ;
begin
dix <= d ;
un <= u ;
compteur : process
begin
	wait until hor = '1' ;
	if u = 9 then 
		if d = 9 then
			d <= 0 ;
		else
			d <= d + 1 ;
		end if ;
		u <= 0 ;
	else
		u <= u + 1 ;
	end if ;
end process compteur ;
end synthese ;
