--cnt4_en.vhd   version compteur modulo4, etat numr

entity compteur is
	port (   hor : in bit;
		en, init : in bit ;
		s : out bit_vector(0 to 3) 
		);
end compteur ;


architecture comporte of compteur is
type etat is (e0,e1,e2,e3) ;
signal actuel,futur : etat ;
begin
evolution : process (actuel,en,init)
begin
	if (en = '1') then
		case actuel is
			when e0 => futur <= e1 ;
			when e1 => futur <= e2 ;
			when e2 => futur <= e3 ;
			when e3 => futur <= e0 ;
			when others => futur <= e0 ;
		end case ;
	else
		futur <= actuel ;
	end if ;
end process evolution ;

synchro : process
begin
	wait until hor = '1' ;
	if(init = '1') then
		actuel <= e0 ;
	else
		actuel <= futur ;
	end if ;
end process synchro ;

with actuel select
	s <=  "1000" when e0,
	 	"0100" when e1,
		"0010" when e2,
		"0001" when e3,
		"1111" when others ;

end comporte ;
