--cnt4_int.vhd   version compteur modulo4, etat entier

entity compteur is
	port (   hor : in bit;
		en, ld : in bit ;
		din : in integer range 0 to 3 ;
		etat: out integer range 0 to 3 ;
		s : out bit_vector(0 to 3) 
		);
end compteur ;


architecture comporte of compteur is
signal actuel : integer range 0 to 3 ;
begin
etat <= actuel ;
with actuel select
	s <=  "1000" when 0,
	 	"0100" when 1,
		"0010" when 2,
		"0001" when 3,
		"1111" when others ;
process
begin
	wait until (hor = '1');
	if(ld = '1') then
		actuel <= din ;
	elsif (en = '1') then
		actuel <= (actuel + 1) mod 4 ;
	end if ;
end process ;
end comporte ;
