-- VHDL Model Created from ECS Schematic cntdec.sch -- Aug 18 13:04:34 1996

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity CNTDEC is
      Port (      en : In    std_logic;
                 hor : In    std_logic;
                zero : In    std_logic;
               carry : Out   std_logic;
                 dix : Out   std_logic_vector (3 downto 0);
                  un : Out   std_logic_vector (3 downto 0) );
end CNTDEC;

architecture SCHEMATIC of CNTDEC is

   SIGNAL gnd : std_logic := '0';
   SIGNAL vcc : std_logic := '1';

   signal   reporte : std_logic;

   component DECADE
      Port (     clk : In    std_logic;
                  en : In    std_logic;
                 raz : In    std_logic;
               count : Out   std_logic_vector (3 downto 0);
                 dix : Out   std_logic );
   end component;

begin

   unite : DECADE
      Port Map ( clk=>hor, en=>en, raz=>zero, count(0)=>un(0),
                 count(1)=>un(1), count(2)=>un(2), count(3)=>un(3),
                 dix=>reporte );
   dizaine : DECADE
      Port Map ( clk=>hor, en=>reporte, raz=>zero, count(0)=>dix(0),
                 count(1)=>dix(1), count(2)=>dix(2), count(3)=>dix(3),
                 dix=>carry );

end SCHEMATIC;
