-- compteur tristate
-- cnt_tri.vhd

library ieee ;
use ieee.std_logic_1164.all, ieee.numeric_std.all ;
-- type UNSIGNED is array (NATURAL range <>) of STD_LOGIC;

entity compteur_tri is
   generic(taille : integer := 10) ;
   port( hor,raz,en,oe : in std_ulogic ;
         compte : out unsigned(taille-1 downto 0) ) ;
end compteur_tri ;

architecture ieee_lib of compteur_tri is
   signal etat : unsigned(taille-1 downto 0) ;
begin
   compte <= etat when oe = '1' else (others => 'Z') ;
   compteur : process
   begin
      wait until rising_edge(hor) ;
      if raz = '1' then
         etat <= (others => '0') ;
      elsif en = '1' then
         etat <= etat + 1 ;
      end if ;
   end process compteur ;
end ieee_lib ;
