-- compteur modulo4, programme correct
-- cpt4_bon.vhd   

entity compteur4 is
   port ( hor : in bit;
      en, raz : in bit ;
          etat: buffer integer range 0 to 3 );
end compteur4 ;

architecture correcte of compteur4 is
   signal futur : integer range 0 to 3 ;
begin
   transitions : process (raz,en,etat)
   begin
      if raz = '1' then
         futur <= 0 ;
      elsif en = '1' then
         futur <= (etat + 1) mod 4 ;
      else
         futur <= etat ; -- traitement par dfaut : maintien dans l'tat
      end if ; 
   end process transitions ;
   evolution : process
   begin
      wait until hor = '1' ;
      etat <= futur ;
   end process evolution ;
end correcte ;

architecture un_process of compteur4 is
begin
   evolution : process
   begin
      wait until hor = '1' ;
      if raz = '1' then
         etat <= 0 ;
      elsif en = '1' then
         etat <= (etat + 1) mod 4 ;
      end if ; -- mmoire synchrone
   end process evolution ;
end un_process ;

architecture val_init of compteur4 is
   signal futur : integer range 0 to 3 ;
begin
   transitions : process (raz,en,etat)
   begin
      futur <= etat ; -- traitement par dfaut : maintien dans l'tat
      if raz = '1' then
         futur <= 0 ;
      elsif en = '1' then
         futur <= (etat + 1) mod 4 ;
      end if ; 
   end process transitions ;
   evolution : process
   begin
      wait until hor = '1' ;
      etat <= futur ;
   end process evolution ;
end val_init ;
