-- des variables et des signaux
-- div_10.vhd

entity div_10 is
	port( 	hor : in bit ;
		sort : buffer bit );
end div_10 ;

architecture boucle of div_10 is
begin
diviseur : process
begin
	for compte in 0 to 4 loop
	wait until hor = '1' ;
		if compte = 4 then
			sort <= not sort ;
		end if ;
	end loop ;
end process diviseur ;
end boucle ;


architecture piege of div_10 is
begin
diviseur : process
variable compte : integer range 0 to 5 := 0 ;
begin
	wait until hor = '1' ;
		compte := compte + 1 ;
		if compte = 5 then
			compte := 0 ;
			sort <= not sort ;
		end if ;
end process diviseur ;
end piege ;

architecture perverse of div_10 is
signal compte : integer range 0 to 4 := 0 ;
begin
diviseur : process
begin
	wait until hor = '1' ;
		compte <= compte + 1 ;
		if compte = 4 then
			compte <= 0 ;
			sort <= not sort ;
		end if ;
end process diviseur ;
end perverse ;


architecture correcte of div_10 is
signal compte : integer range 0 to 4 := 0 ;
begin
diviseur : process
begin
	wait until hor = '1' ;
		if compte = 4 then
			compte <= 0 ;
			sort <= not sort ;
		else
			compte <= compte + 1 ;
		end if ;
end process diviseur ;
end correcte ;

architecture modulo5 of div_10 is
	signal compte : integer range 0 to 4 := 0 ;
begin
diviseur : process
begin
	wait until hor = '1' ;
		compte <= (compte + 1) mod 5 ;
		if compte = 4 then
			sort <= not sort ;
		end if ;
end process diviseur ;
end modulo5 ;
