-- test de l'espion
-- espi_tst.vhd

entity espi_tst is end espi_tst ;

architecture ww of espi_tst is
   component espion is
      generic(taille : integer := 8) ;
      port(observe : in bit_vector(0 to taille - 1) ) ;
   end component espion ;
   signal decode : bit_vector(0 to 7) := X"FF" ;
begin
   surveille : espion generic map(8)
                      port map(decode) ;
   decode <= X"FE" after 10 ns, 
             X"7E" after 20 ns, 
             X"FF" after 30 ns,
             X"00" after 100 ns ;
end ww ;
