-- mux2_1.vhd

entity mux2_1 is
	port(e0,e1 : in bit ;
		 sel : in bit ;
		 sort : out bit ) ;
end mux2_1 ;

architecture comporte of mux2_1 is
begin
process (e0,e1,sel)
begin
	if sel = '0' then
		sort <= e0 ;
	else
		sort <= e1 ;
	end if ;
end process ;
end comporte ;

architecture flot of mux2_1 is
signal sele0, sele1 : bit ;
begin
	sort  <= sele0 or sele1 ;
	sele0 <= e0 and not sel ;
	sele1 <= e1 and sel ;
end flot ;

architecture struct of mux2_1 is
component et
	port (a, b : in bit ; s : out bit) ;
end component ;

component ou
	port (a, b : in bit ; s : out bit) ;
end component ;

component non
	port (a : in bit ; s : out bit) ;
end component ;
signal nonsel, sele0, sele1 : bit ;
begin
result  : ou  port map(sele0, sele1, sort) ;
complem : non port map(sel, nonsel) ;
choix0  : et  port map(nonsel, e0, sele0) ;
choix1  : et  port map(sel, e1, sele1) ;
end struct ;
