-- mux4_1.vhd

entity mux4_1 is
	port(e0,e1,e2,e3 : in bit ;
		 sel4 : in bit_vector(1 downto 0) ;
		 sort : out bit ) ;
constant zero  : bit_vector(1 downto 0) := "00" ;
constant un    : bit_vector(1 downto 0) := "01" ;
constant deux  : bit_vector(1 downto 0) := "10" ; 
constant trois : bit_vector(1 downto 0) := "11" ;
end mux4_1 ;

architecture essai of mux4_1 is
begin
process (e0,e1,e2,e3,sel4)
begin
	case sel4 is
		when zero   => sort <= e0 ;
		when un     => sort <= e1 ;
		when deux   => sort <= e2 ; 
		when trois  => sort <= e3 ;
	end case ;
end process ;
end essai ;

architecture ess_with of mux4_1 is
begin
with sel4 select
	sort <=	e0 when zero ,
		e1 when un ,
		e2 when deux ,
		e3 when trois ,
		'0' when others ;
end ess_with ;


