-- mux_tri.vhd
-- test de syntaxe : genericite et bloc

library ieee ;
use ieee.std_logic_1164.all ;

entity muxN_1_tri is
generic ( dimension : integer := 4 ) ;
	port(  entree : in std_logic_vector(dimension -1 downto 0) ;
		oe : in bit ;
		 sel : in integer range 0 to dimension - 1 ;
		 sort : out std_logic ) ;
end muxN_1_tri ;


architecture essai_bloc of muxN_1_tri is
signal interne : std_logic bus ;
begin
sort <= interne ;
mux : block (oe = '1') is
begin
interne <= guarded entree(sel) ;
end block mux ;
end essai_bloc ;

architecture essai_bloc1 of muxN_1_tri is
begin
mux : block (oe = '1') is
	generic( taille : integer := 2 ) ;
	generic map( taille => dimension ) ;
	port (	adresse : in integer range 0 to taille - 1 ;
		din : in std_logic_vector(taille -1 downto 0) ;
		sort : out std_logic );
	port map (adresse => sel, din =>entree , sort => sort ) ;
	signal interne : std_logic bus := 'Z' ;
begin
interne <= guarded din(adresse) ;
sort <= interne ;
end block mux ;
end essai_bloc1 ;
