-- procdures : additionneur complet
-- proc_add.vhd

-- procedure add(signal a, b, cin : in bit;
--                 signal s, cout : out bit ) ;

entity adder is
   generic(taille : integer := 4) ;
   port(e1, e2 : in bit_vector(0 to taille - 1) ;
          cyin : in bit ;
           som : out bit_vector(0 to taille - 1) ;
         cyout : out bit ) ;
end adder ;

architecture tordue of adder is

procedure add(signal a, b, cin : in bit;
                signal s, cout : out bit ) is
variable entree : bit_vector(0 to 2) ;
variable impair, deux : bit := '0' ;
begin
   entree := a & b & cin ;
   for i in entree'range loop
      if entree(i) = '1' then
         impair := not impair ;
         if impair = '0' then
            deux := '1' ;
         end if ;
      end if ;
   end loop ;
   s <= impair ;
   cout <= deux ;
end procedure add ;

signal retenues : bit_vector(0 to taille) ;

begin
retenues(0) <= cyin ;
cyout <= retenues(taille) ;
boucle :  for i in 0 to taille - 1 generate
      add(e1(i),e2(i),retenues(i),som(i),retenues(i+1)) ; 
end generate ;
end tordue ;
