-- reg_gen.vhd
-- test de syntaxe : genericite
library ieee ;
use ieee.std_logic_1164.all ;

entity registre_N is
	generic ( dimension : integer := 8 ) ;
	port(hor, direction : in bit ;  
		 donnee : inout std_logic_vector(dimension - 1 downto 0) ) ;
end registre_N ;


architecture essai of registre_N is
signal temp : std_logic_vector(dimension - 1 downto 0) ;
begin
donnee <= temp when direction = '0' else (others => 'Z') ;
process
begin
	wait until hor = '1' ;
	if direction = '1' then
		temp <= donnee ;
	end if ;
end process ;
end essai ;

