-- encodeur ami
-- amidec.vhd

entity amicod is
	port( 	hor, din : in bit ;
		plusout, moinsout : out bit );
end amicod ;

architecture sort_decode of amicod is
type ami is (mzero,pzero,moins,plus) ;
signal etat : ami ;
begin
plusout  <= '1' when etat = plus  else '0' ;
moinsout <= '1' when etat = moins else '0' ;
encode : process
begin
	wait until hor = '1' ;
	case etat is
		when mzero => 	if din = '1' then etat <= plus  ; 
				end if ;
		when pzero => 	if din = '1' then etat <= moins ; 
				end if ;
		when moins => 	if din = '1' then etat <= plus ;
				else etat <= mzero ; 
				end if ;
		when plus  => 	if din = '1' then etat <= moins ;
				else etat <= pzero ; 
				end if ;
		when others =>	etat <= mzero ;
	end case ;
end process encode ;	
end sort_decode ;