-- du combinatoire au squentiel
-- comb_seq.vhd

entity comb_seq is
	port (
		e1, e2 : in  bit ;
		s_et, s_latch, s_edge : out bit
		) ;
end comb_seq ;

architecture ww of comb_seq is
begin

et : process -- (e1,e2)
begin
	wait on e1, e2 ;
	if( e1 = '1' ) then
		s_et <= e2 ;
	else
		s_et <= '0' ;
	end if ;
end process ;

latch : process --(e1,e2) 
begin
	wait on e1, e2 until e1 = '1' ;
--	if( e1 = '1' ) then
		s_latch <= e2 ;
--	end if ;
end process ;

edge : process --(e1) 
begin
	wait on e1 until e1 = '1' ;
--	if( e1 = '1' ) then
		s_edge <= e2 ;
--	end if ;
end process ;
end ww ;
