-- aspect dynamique des variables d'une procdure ou d'une fonction
-- dynam.vhd

entity dynam is end dynam ;

architecture simple of dynam is
   signal stim, f_ssprg, p_ssprg, procmem, procoubli  : integer := 0 ;
   function essf (signal sin : integer) return integer is
      variable coeff : integer := 2 ;
      begin
         coeff := coeff * 2 ;
         return sin + coeff ;
      end function essf ;
   procedure essp (signal sin : in integer ;
                  signal sort : out integer) is
      variable coeff : integer := 2 ;
      begin
         coeff := coeff * 2 ;
         sort  <= sin + coeff ;
      end procedure essp ;
begin
   stim    <= 6 after 10 ns, 0 after 20 ns ;
   f_ssprg <= essf(stim) ;
   essp(stim, p_ssprg) ;
   
memoire : process ( stim )
      variable coeff : integer := 2 ;
   begin
         coeff := coeff * 2 ;
         procmem  <= stim + coeff ;   
   end process memoire ;
oubli : process ( stim )
      variable coeff : integer ;
   begin
         coeff := 2 ;
         coeff := coeff * 2 ;
         procoubli  <= stim + coeff ;   
   end process oubli ;
end simple ;
