-- modle d'inverseur
-- inverse.vhd

library ieee ;
use ieee.std_logic_1164.all ;

entity als_04 is
   generic(tplh : time := 11 ns ;
           tphl : time :=  8 ns ) ;
   port(a :  in std_logic ;
        y : out std_logic ) ;
end als_04 ;

architecture retard of als_04 is
begin
   y <= '1' after tplh when a = '0' 
        else '0' after tphl ;
end retard ;

use work.temporel.all ;

architecture generale of als_04 is
begin
inv : process (a)
   variable futurs, anciens : std_logic ;
   begin
    -- fonctionnement logique idal :
      futurs := not a ;
    -- transaction avec retards :
      propagat(sortie => y,
               nouvelle => futurs,
               ancienne => anciens,
               tlh => tplh, thl => tphl) ;
end process inv ;
end generale ;
