-- operateur OU exlusif generalise
-- parite.vhd

use work.par_pkg.all ;

ENTITY ouex IS
   generic(taille : integer := 8) ;
   PORT ( a : IN  BIT_VECTOR(0 TO taille - 1) ;
          s : OUT BIT );
END ouex;

ARCHITECTURE parite of ouex is
BEGIN
process(a)
variable parite : bit ;
begin
   parite := '0' ;
   FOR i in a'range LOOP	
      if a(i) = '1' then
         parite := not parite;
      end if;
   END LOOP;
   s <= parite;
end process;
END parite;

ARCHITECTURE proc of ouex is

BEGIN
   calcproc(a,s) ;
END proc ;

ARCHITECTURE fonct of ouex is

BEGIN
   s <= calcfonc(a) ;
END fonct ;
