-- operateur OU exlusif generalise paquetage
-- par_pkg.vhd

package par_pkg is
   procedure calcproc (signal e : in bit_vector ; 
                  signal impair : out bit ) ;
   function calcfonc (signal e : in bit_vector ) return bit ;
end package par_pkg ;

package body par_pkg is

procedure calcproc (signal e : in bit_vector ; signal impair : out bit ) is
variable parite : bit := '0' ;
begin
   FOR i in e'range LOOP	
      if e(i) = '1' then
         parite := not parite;
      end if;
   END LOOP;
   impair <= parite;
end procedure calcproc ;


function calcfonc (signal e : in bit_vector ) return bit is
   variable parite : bit := '0' ;
begin
   FOR i in e'range LOOP	
      if e(i) = '1' then
         parite := not parite;
      end if;
   END LOOP;
   return parite;
end function calcfonc ;

end package body par_pkg ;

