-- operateur OU exlusif generalise
-- proc_par.vhd

ENTITY ouex IS
   generic(taille : integer := 8) ;
   PORT ( a : IN  BIT_VECTOR(0 TO taille - 1) ;
          s : OUT BIT );
END ouex;

ARCHITECTURE parite of ouex is
BEGIN
process(a)
variable parite : bit ;
begin
   parite := '0' ;
   FOR i in a'range LOOP	
      if a(i) = '1' then
         parite := not parite;
      end if;
   END LOOP;
   s <= parite;
end process;
END parite;

ARCHITECTURE proc of ouex is

procedure calcproc (signal e : in bit_vector ; signal impair : out bit ) is
variable parite : bit := '0' ;
begin
   FOR i in e'range LOOP	
      if e(i) = '1' then
         parite := not parite;
      end if;
   END LOOP;
   impair <= parite;
end procedure ;

BEGIN
   calcproc(a,s) ;
END proc ;

ARCHITECTURE fonct of ouex is

function calcfonc (signal e : in bit_vector ) return bit is
variable parite : bit := '0' ;
begin
   FOR i in e'range LOOP	
      if e(i) = '1' then
         parite := not parite;
      end if;
   END LOOP;
   return parite;
end function ;

BEGIN
   s <= calcfonc(a) ;
END fonct ;
