-- extension de signe
-- sig_ext.vhd

entity sig_ext is
   port(en : in bit_vector(3 downto 0) ;
         sortie : out bit_vector(6 downto 0 )) ;
end sig_ext ;

architecture fonc of sig_ext is
   function extend(source : bit_vector ; constant size : natural)
         return bit_vector is
      variable result : bit_vector((source'low + size -1) downto source'low);
   begin
      result(source'range) := source ;
      for i in source'high to (source'low + size -1) loop
         result(i) := source(source'high) ;
      end loop ;
      return result ;
   end function extend ;
   
   constant long : natural := 7 ;
begin
   sortie <= extend(en,long) ;
end fonc ;
