-- typedef.vhd pot pourri de dfinitions de types et de constantes
package typedef is
type table is array (bit,bit,bit) of bit_vector (0 to 7) ;
constant decode : table  :=
       ((("01111111",    --000
          "10111111"),   --001
         ("11011111",    --010
          "11101111")),  --011
        (("11110111",    --100
          "11111011"),   --101
         ("11111101",    --110
          "11111110"))); --111

	type octet is range 0 to 255 ;
	type valim is range 0.0 to 5.0 ;
	type mem8 is array (0 to 1023) of octet ;
constant rom_vide : mem8 := (others => 16#FF#) ;
constant rom_presque_vide : mem8 := (0 to 10 => 3, others => 255);
	type adresse is range mem8'range ;
	constant essai : octet := 3 + 5 ;
	subtype mot is integer range -32768 to 32767 ;
	constant ess1 : mot := 6 + 8 ;
	type table_verite_2 is array(bit,bit) of bit ;
	constant ouex_tv : table_verite_2 := (('0','1'),('1','0')) ;
	constant ouex_tv2 : table_verite_2
		 := ('0'=>('0'=>'0','1'=>'1'),
		     '1'=>('0'=>'1','1'=>'0')) ;
	constant ouex_tv1 : table_verite_2 := ("01","10") ;
type nom_de_mois is (jan,fev,mar,avr,mai,jun,
                     jul,aou,sep,oct,nov,dec) ;
type date is
      record
         jour  : integer range 0 to 31 ;
         mois  : nom_de_mois ;
         annee : integer range -2000 to 4000 ;
end record date ;

constant bastille : date := (14,jul,1789) ;
constant bast2 : date := (mois => jul,annee => 1789,jour => 14) ;
constant bast1 : date := bastille ;
type x01z is ('x','0','1','z') ;
constant zero : bit := '0' ;
constant zero1 : x01z := x01z'('0') ;
constant pi : real := 3.14159 ;
constant intpi : integer := integer(10000.0*pi) ;

end typedef ;
