-- T_edge.vhd

entity T_edge is
   port ( T,hor : in bit;
              s : out bit);
end T_edge;

architecture mauvaise of T_edge is
   signal etat : bit ;
begin
s <= etat ;
process (hor)
begin
   if hor'event and hor = '1' and T = '1' then
      etat <= not etat ;
   end if ;
end process ;
end mauvaise ;

architecture bonne of T_edge is
   signal etat : bit ;
begin
s <= etat ;
process (hor)
begin
   if hor'event and hor = '1' then -- recherche du front
      if T = '1' then
         etat <= not etat ; -- action synchrone
      end if ;
   end if ;
end process ;
end bonne ;

